using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using Unity;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Energy Sword"),
                    NameOverride = "RGB Energy Sword",
                    DescriptionOverride = "You can change color energy sword.",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Sprites/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var component = Instance.AddComponent<ColorfulEnergySword>();
                        component.blade = ModAPI.LoadSprite("Sprites/blade.png");
                    }
                }
            );
        }
    }
    public class ColorfulEnergySword : MonoBehaviour
    {
        public Sprite blade;
        public Color newColor;
        public Color oldColor;
		public Color RGB;
        public float interp = 0f;
        public float counter = 0f;

        private string[] particleObjectsNames = new string[]
        {
            "Embers",
            "Flash",
            "ElectricBoltBranch",
            "SmokeParticle",
            "SpriteLightFlash"
        };
        private void Update()
        {
            if (interp == 0f)
            {
                oldColor = gameObject.transform.Find("blade").GetComponent<SpriteRenderer>().color;
                newColor = UnityEngine.Random.ColorHSV(0f, 1f, 0.75f, 0.75f, 0.75f, 0.75f);
            }
            else if (interp >= 1f)
            {
                interp = 0f;
                return;
            }
            interp += Time.deltaTime * 2;
            counter += Time.deltaTime;
			RGB = UnityEngine.Color.Lerp(oldColor, newColor, Math.Min(interp, 1f));
            gameObject.transform.Find("blade").GetComponent<SpriteRenderer>().color = RGB;
            gameObject.transform.Find("blade/overlay").GetComponent<SpriteRenderer>().color = RGB;
            gameObject.transform.Find("blade/Glow").GetComponent<SpriteRenderer>().color = RGB;
            Transform energySwordImact = gameObject.transform.Find("EnergySwordImpact");
            foreach (string gameObjectName in particleObjectsNames)
            {
                energySwordImact.Find(gameObjectName).gameObject.GetComponent<ParticleSystem>().startColor = RGB;
            }
			var material = gameObject.GetComponent<EnergySwordBehaviour>().MotionBlur.GetComponent<MeshRenderer>().material;
            material.SetColor("_GlowColour", RGB*10);
        }
    }
}